"""A very first peewit experiment. 
"""

## the native peewit classes needed for any peewit experiments
from peewit.core import Experiment, ENode

from cut.baseclass import Named


#### 1) project configuration

from project_conf import PK



#### 2) e-nodes 

class rabbit(ENode):
    
    def descent(self):
        return [ 'a', 'b' , 'c', 'd']


## a class use by the node 'carrot'
class Tube(Named):
    def init(self, line=None):
        pass
    
    def get_name(self):
        return self.classname() + '_' + str(self.line)
 
class carrot(ENode):
    def descent(self):
        A = Tube(line=1)
        B = Tube(line=2)
        C = Tube(line=3)        
        return [ A, B, C ]


class kasha(ENode):
    def descent(self, rabbit, carrot ):
        
        def h(x,y,z):
            return  abs(("abcd".index(x)**2 - 5*z  ) * y.line )
            
        d2 = h(rabbit, carrot, 2)
        d3 = h(rabbit, carrot, 3)
        
        return [ d2, d3 ]
    
    def explicit_descent_labels(self):
        return ["He", "Hu"]




#### 3) definition of the e-tree 

etree = [ rabbit(),
          carrot(), 
          kasha(), 
        ]


#### 4) application/run of the e-tree

if __name__ == '__main__':

    
    EP = Experiment(pathkeeper = PK,
                    version    = 0,     
                    )
    
    
    ## read and digest specification 
    EP.define(etree)

    ## go 
    vc = EP.run()
    
    ## store v-cube
    vc.save()
    
    ## create an object that cares for presentation of result data cube
    
    ## if you do have matplot installed, uncomment this
    #from peewit.paths import PathKeeper
    #PathKeeper.use_pylab = 0
    
    vc.show()

    
    


