""" In this example you can see how service on v-cubes are used."""

from project_conf import *

from example_1 import data,sample, kernel, c, algorithm, kernel_tray
from peewit.core import Experiment, ENode
from peewit.vcubes import VCube, Manipulation


from peewit.presentation import Viewer
from collections import OrderedDict
 

        

class c(ENode):
    
    def descent(self):
        return list(range(2,8))

class leaf(ENode):

    def descent(self, algorithm, data, sample):
        
        A, E   = sample
        
        model  = algorithm.train(A)
        
        Y      = data.get_YS(E)
        
        Y_hat  = algorithm.predict(model, E) 
        
       
        accuracy   =  1. * sum(  Y == Y_hat ) / sum( ( Y == 1 ) + (Y == -1) )
        precision  =  1. * sum( (Y == 1 ) * (Y_hat == 1) ) / sum( Y_hat == 1 )
        recall     =  1. * sum( (Y == 1 ) * (Y_hat == 1) ) / sum( Y == 1 )
        
        
        return [  accuracy , precision, recall  ]
             
    def explicit_descent_labels(self):
        return [ 'accuracy', 'precision', 'recall' ]
   

etree = [     data(),
              sample(), 

              kernel(),
              kernel_tray(),
              c(),
              algorithm(), 
              leaf(),
        ]



if __name__ == '__main__':


    E = Experiment(pathkeeper=PK,
                   version   = 4
                   )
    E.define(etree)

    vc = E.run()
    
    vc.save()

    vi = Viewer(vc)
    
    vi.print_vcube(fixed_length=6)
    
    ## plot with non-singleton dimension
    vc = vc.aggs([ ('sel', 'leaf', 'accuracy'),
                   ('sel', 'data_source', 'sonar') 
                   ])
    
    
    vi = Viewer(vc)

   
    ## puts plots in a proper cube 
    vcp = vi.build_plots( markersize=0.5, )
    
    vi.save_plots()

    ## or load it 
    #VCube.pathkeeper = PK  
    #vc  = VCube(basename="example_2--4--leaf--plain")
        
    vc = vc.aggs([('mean', 'sample')])
    # switch dim order
    Manipulation.partially_permute(vc,['c','kernel',])
    ## Note that aggregation of the target-dim leaf over the dim sample makes all
    ## other dim that depend on sample void. 
    vc.show()

    
    
    
