"""In this module we read result cube from peewit experiments that
have been run before. You can see here how v-cube are loaded and manipulated 
in preparation to build textual or graphical outputs."""


from project_conf import PK

from peewit.vcubes import VCube
from peewit.presentation import Viewer


VCube.pathkeeper = PK


if 1:
    
    ## quick access by full name of v-cube
    ## it has four name parts separated by double dash
    vc  = VCube(basename='example_1--6--leaf--plain')
    
    ## or via pathkeeper from project_conf
    #PK.treename      = 'example_1'
    #PK.version       = '6'
    #PK.partname      = 'plain'
    #PK.target_ename  = 'leaf' 
    #vc = VCube(pathkeeper=PK)
    
    ## create object that cares for presentation of result cube
    vi = Viewer(vc)
    vi.print_vcube()


    ## aggregation return new v-cube object
    vi.vcube = vc.aggs([('mean','sample')])   
    vi.print_vcube()


    

    
    
    
