from cut.baseclass import Named
from numpy import array

class LLMM(Named):
    """Linear Large Margin Modell"""
    def init(self,
             beta=None,
             tau=None,
             sign= +1,
             maker=None,
             dummy=False,
             stats={}
             ):
        
        assert sign in [ -1, +1]
        pass

    def predict(self, E, more=False):
        if self.dummy:
            Y_hat = array([-1] * len(E))
            m     = array([0] * len(E))
            if more:
                return Y_hat,m
            else:
                return array([-1] * len(E))
        else:
            return self.maker.predict(self, E, more=more)

class SOS(Named):
    """Sequences of One Sided models."""
    def init(self,
             sequence=[],
             maker=None,
             complete=False):
        pass

    def predict(self, T):

        Y_hat = []
        cutted = []
        
        for t in T:    
            cuts = self.sequence[:-1]
            final = self.sequence[-1]
            early_commit = False
            for model_cut in cuts:
                y_hat_ = model_cut.predict([t]).ravel()
                if y_hat_ == +1: 
                    early_commit = True
                    y_hat = model_cut.sign
                    cutted += [t]
                    break
            
            if not early_commit:
                y_hat_ = final.maker.predict(final, [t]).ravel()[0]
                y_hat = y_hat_ * final.sign 
                   
            Y_hat += [ y_hat  ]        
                
        return array(Y_hat), cutted

if __name__ == '__main__':
    pass
