"""
The package contains the core modules of peewit, a system to support 
simple machine learning experiments. 
Project homepage: U{http://www.ke.tu-darmstadt.de/resources/peewit/}

The package currently contains six modules.

    1. core
    This is the central module. It implements a model of experiments, called
    I{peewit-model}. To run an experiment, you use the class Experiments.   

    2. vcubes
    The results of an experiment are collected into v-cubes. A peewit run 
    produces a I{pv-tree}, and a single v-cube holds values from the a pv-tree stemming 
    all from one level of the tree. The module implements the class VCubes that 
    has functions to handle v-cubes.

    3. paths
    Anything that is related to path handling goes trough this module and its main 
    class PathKeeper.

    4. archiving
    peewit can be told to store the current state just before running an experiment 
    by means of mercurial, a version control system. The archiving module manages this.
    
    5. paralellization
    With this module painless parallelization of experimental runs is possible.
    
    6. presentation
    This module takes care for presentation of results. It displays
    the values contained in a v-cube either as text-output or by 
    generation of plots. 

The modules of this package depend on the modules of pw_toolbox package.


Copyright (C) 2010 by the peewit developers. 
This program is free software: you can redistribute it and/or modify it under 
the terms of the GNU General Public License version 3 (GPLv3) as published by 
the Free Software Foundation. The terms and conditions of this license are
given in doc/licence.txt or at U{http://www.opensource.org/licenses/gpl-3.0.html}. 

"""
