
from cut.baseclass import Named
from cut.numpytools import argmax_nd
from cut.container import indices
from collections import OrderedDict

from numpy import array, nan
#from random import shuffle

import difflib

class SequenceMatcher(Named):
    
    
    def init(self, 
             Q ):
        
        self.set_Q(Q)
    
    def set_Q(self, Q):
        
        self.Q = array(Q)
        
        
        
    def match(self):
    
        pass
    
    @staticmethod
    def string_similarity(x,y):
        return difflib.SequenceMatcher(None, x, y).ratio()

    
    
class LTMatcher(SequenceMatcher):
    
    def match(self):
        
        #assert all([ not q is nan for q in  self.Q.ravel()])
                
        Q = self.Q.copy()
        
        matching = OrderedDict()
        change   = True
        free     = set(range(Q.shape[0]))
        while (change and free):
            
           
            i,j  = argmax_nd(Q)
            
            if not Q[i,j] is nan: 
                matching[i] = j             
                Q[i,:] = nan
                Q[:,j] = nan
                free.remove(i)
                change = True
            else:
                change = False
            
        matching_ = OrderedDict()
        
        for i in indices(Q):
            matching_[i] = matching[i]
        
        return matching_
    

if __name__ == '__main__':
    
    pass    
