#!/bin/bash

## This script should run on every linux with internet connection and having installed the following:
## python 2.6 (or 2.7) numpy, matplotlib, python-libsvm
## It downloads the peewit framework, unpacks it, set peewit on PYTHONPATH, and
## runs an example-experiment
## The main goal is to check wether the current peewit distro as linked on peewits home 
## page is not missing any part (what happend in the past several times).

set -e


TESTDIR=peewit
DISTRO=peewit_0.10
DOWNLOADURL="http://www.ke.tu-darmstadt.de/resources/peewit/$DISTRO/at_download/file"
BASEDIR=pw_base/
PROJECTDIR=example_project/

rm -rf $TESTDIR
mkdir -p $TESTDIR


cd $HOME/$TESTDIR
#wget -O $DISTRO.tar.gz $DOWNLOADURL
cp $HOME/$DISTRO.tar.gz ./
tar xzf $DISTRO.tar.gz
cd $BASEDIR/$PROJECTDIR
mkdir -p .peewit/
echo $TESTDIR/$BASEDIR > .peewit/base_dir
export PYTHONPATH=$HOME/$TESTDIR/$BASEDIR/python/
export PYTHONPATH=${PYTHONPATH}:${MATPLOTLIB}/
#export LIBSVMPATH=$HOME/modules_extended_64/libsvm-3.11/python
#export PYTHONPATH=${PYTHONPATH}:${LIBSVMPATH}/
echo PYTHONPATH=$PYTHONPATH
python3 python/example_0.py

#cd $HOME/$TESTDIR/$BASEDIR/unittests/
#python3 python/main.py





