import unittest

from peewit.core   import Experiment, ENode
from peewit.vcubes import VCube, Manipulation
from peewit.presentation import Viewer


import project_conf
#reload(project_conf)

PK = project_conf.PK
#AR = project_conf.AR
VCube.pathkeeper = PK
from basics import rabbit,carrot, kasha, Tube

class kasha(ENode):
    def descent(self, rabbit, carrot ):
        
        def h(x,y,z):
            return  abs(("abcd".index(x)**2 - 5*z  ) * y.line )
            
        d2 = h(rabbit, carrot, 2)
        d3 = h(rabbit, carrot, 3)
        
        return [ d2, d3 ]
    
    ## no explicit_descent_labels
        
class Inspection(unittest.TestCase):
    
     
    def test_label_guess(self): 
        
        E = Experiment( pathkeeper = PK,
                        version    = 0,
                      )
        
        etree = [   rabbit(),
                    carrot(#labels_from_varnames=0
                           ), 
                    kasha(), 
                ]
        
        E.define(etree)
        Experiment.treenames = set()
        
        tr  = E.tree_runner
        
        enode = etree[1]
        
        #labels = tr.labels_from_varnames(enode.descent)
        
        #print labels
        
        vc = E.run()
            
        vc.show()
        vc.check()
        
        
        self.assert_(vc.vcubes['kasha'].value_labels ==  ['d2', 'd3'] )
        
        
        

"""
def descent(x,uuu):
    v = 88
    Yh = 00
    if (3 != 5):
        sorted([])
        
    return [v,Yh]
""" 