import unittest

from peewit.core   import Experiment, ENode
from peewit.vcubes import VCube


import project_conf
#reload(project_conf)

PK = project_conf.PK
#AR = project_conf.AR
VCube.pathkeeper = PK
from basics import rabbit,carrot, kasha

class fan(ENode):
    
    def descent(self):
        
        return [1,2]
    
class game(ENode):
    
    def descent(self, fan, kasha):
        
        X = fan * kasha
        
        return [ X ]
    
class rabbit2(ENode):
    def descent(self):
        #return [ 'a', 'b' , 'c', 'd']  
        return [ 'b' , 'd']  
        
class Loading(unittest.TestCase):
    
    
    def setUp(self):
        self.E = E = Experiment( pathkeeper = PK,
                        version    = 0,
                        verbose_descent = None,#['kasha'],
                      )
        
        etree = [   rabbit(),
                    carrot(), 
                    kasha(), 
        ]
        
        E.define(etree)
        Experiment.treenames = set()
        
                
        self.vc = vc = E.run()
        
        vc.check()
        self.basename = vc.pathkeeper.basename()

        vc.save()


    def test_pvc(self): 
        
        vc1 = VCube(basename=self.basename)
        vc1.show()
        
        ## change rabbit descent function
        def descent():
            ##return [ 'a', 'b' , 'c', 'd']
            return [ 'a', 'b' ]
        
        rabbit_new = rabbit()
        rabbit_new.descent = descent
        
        ## should not change anyting as we use pre-computed cube
        etree_ = [  rabbit_new,
                    carrot(), 
                    kasha(
                          pdvc=vc1
                          ),
                  ]
        
        E2 = Experiment( pathkeeper = PK,
                         version     = 0,
                         verbose_descent = None,#['kasha'],
                      ) 
        
        E2.define(etree_)
         
        vc2 = E2.run()
        
        self.assert_(vc1.equals(vc2))
        
        #print(vc2.get_values())
        
        
      
    def test_vcnode(self): 
        
        vc1 = VCube(basename=self.basename)
        vc1.show()
        
        etree_ = [  fan(),
                    rabbit2(),
                    vc1(input_refs=[['rabbit', 'rabbit2']]),
                    game(),
                  ]
        
        E2 = Experiment( pathkeeper = PK,
                         version     = 0,
                         verbose_descent = None,#['kasha'],
                      ) 
        
        E2.define(etree_)
         
        vc2 = E2.run()
        vc3 = vc2.aggs([('sel', 'fan',     '1'),
                        ('sel', 'rabbit2', 'd'),
                        ])
        
        #vc3.show()        
        vc4 = self.vc.aggs([('sel', 'rabbit', 'd')])
        #vc4.show()
        self.assert_( all(vc3.cube.ravel() == vc4.cube.ravel())  )
        
        
if __name__ == "__main__":
    import main
    main.run_name('load.Loading.test_pvc')
    
        