import unittest

from peewit.core   import Experiment, ENode
from peewit.vcubes import VCube, Manipulation
from peewit.presentation import Viewer


import project_conf
from numpy.lib.function_base import nanargmax
#reload(project_conf)

PK = project_conf.PK
#AR = project_conf.AR
VCube.pathkeeper = PK
from basics import rabbit,carrot, kasha, Tube


class bike(ENode):
    
    pass
            
class Manipulating(unittest.TestCase):
    
    
    def setUp(self):
        
        E = Experiment( pathkeeper = PK,
                        version    = 0,
                        verbose_descent = None,#['kasha'],
                      )
        
        etree = [   rabbit(),
                    carrot(), 
                    kasha(), 
        ]
        
        E.define(etree)
        Experiment.treenames = set()
                  
        self.vc = E.run()
        
    
    def test_renaming(self): 
        
        vc = self.vc
        
        Manipulation.rename_dim(vc, 'kasha', 'mana')
        Manipulation.rename_dim(vc, 'rabbit', 'rudi')
        
    
        self.assert_(vc.dim_names()[2] == 'mana')
        self.assert_(vc.vcubes['mana'] is vc)
        self.assert_(vc.vcubes['rudi'].dim_names()[0]  == 'rudi')
        
        
        
    def test_aggregation(self): 
        
        vc = self.vc
        
        vc.show()
        
        #vc_ = vc.aggs([('argmax', 'kasha')])
        vc_c = vc.aggs([('argmax', 'carrot')])
        vc_r = vc.aggs([('max', 'rabbit')])
        #vc_ = Manipulation.arg_ag_objects(vc, ['carrot'], nanargmax)
        #vc_ = Manipulation.arg_ag_objects(vc, ['kasha'], nanargmax)
        
        self.assert_(vc.vcubes['carrot'].cube[(2)] is vc_c.cube[(0,1)])
        
        vc_r.show()
        
        