import unittest, os

from peewit.core   import Experiment, ENode
from peewit.vcubes import VCube
from peewit.presentation import Viewer


import project_conf
#reload(project_conf)

PK = project_conf.PK
AR = project_conf.AR

from basics import etree


class Plotting(unittest.TestCase):
    
    def setUp(self):
        self.E  =\
        E = Experiment( pathkeeper = PK,
                        version    = 0,
                        verbose_descent = None,#['kasha'],
                        archivist=AR,
                      )
        
        
        self.etree = etree
        
        E.define(self.etree)
        
        Experiment.treenames = set()
        
        
    def test_build_plots(self): 
        
        vc = self.E.run()
        
        vi = Viewer(vc)   

        vi.print_vcube(squeeze_it=0) 
        
        
        if "DISPLAY" in os.environ and\
           os.environ["DISPLAY"]:
            vi.build_plots(inner_dims=['rabbit','carrot'])
            vi.save_plots()
    
            vi.build_plots(inner_dims=['rabbit','kasha'])
            vi.save_plots()
        else:
            print("No $DISPLAY, test 'test_build_plots' void.")
    