from peewit.paths import PathKeeper 
from peewit.archiving import Archivist
from peewit.parallelization import Launcher, SGE_Launcher

PK = PathKeeper()
 
PK.group           = 'ke_tud_de'
PK.base_dir        = 'code/peewit/pw_base/' 
PK.project_dir     = 'unittests/'
PK.python_paths    = [] #['example_user_packages/',]

## some paths may depend on architecture, 32 versus 64 bit
#PK.python_paths_32 = ['../../modules_extended_32/libsvm-2.86/python/' ]
#PK.python_paths_64 = ['../../modules_extended_64/libsvm-2.86/python/' ]
PK.python_paths_os = [] 



AR = Archivist()

AR.more_dirs = []
AR.exclude_from_archive += PK.python_paths_32 + PK.python_paths_64
#AR.repos_passive_integration = []
#AR.repos_active_integration  = []

#AR.omit_pyd_files = True
#AR.pull_peewit()
#AR.verbosity = 1


class Launcher_E3(SGE_Launcher):
   
    def init(self,
        remote_head              = 'cluster',
        remote_head_architecture = '64bit',
        remote_user              = 'lw',
        remote_home_dir          = '/nfs/cluster_files/lw/',
        queue                    = 'all.q@@rack',
        path_cluster_settings    = '/usr/local/sge-root/default/common/settings.sh'

             ): 
        pass



LC = Launcher_E3()

LC.python                    = 'python3'
LC.notification_mail_address = 'lorenz@ke.tu-darmstadt.de'
LC.sync_executable_32        = '../../../rechner/programme/unison-2.27'
LC.sync_executable_64        = '../../../rechner/programme/unison-2.27_64bit'

LC.verbose_sync              = 1


#LC.remote_base_dir     = None
#LC.remote_peewit_path = 'peewit/pw_base/python/'
LC.remote_sync_executable_32  = '../../../rechner/programme/unison-2.27'
LC.remote_sync_executable_64  = '../../../rechner/programme/unison-2.27_64bit'
LC.remote_python_paths_os     = []    
LC.exclude_from_sync          = [
                                  'modules_extended_32/libsvm-3.16/python',
                                  'modules_extended_64/libsvm-3.16/python',
                                ]





PK.digest_paths(AR, LC)


